unit tree_lib;

interface

	function init: longint;

	function neighbor_count( point: longint ): longint;
	function neighbor( point, index: longint ): longint;

	function decoration( point: longint ): char;

	function enemy: longint;
	procedure decorate( point: longint; decoration: char );

implementation

type
	neighbors_t = array[ 0..10000000 ] of longint;
	neighbors_p = ^neighbors_t;
	point_t = record
		neighbor_count: longint;
		neighbors: neighbors_p;
		decoration: char;
	end;
	points_t = array[ 0..10000000 ] of point_t;
	points_p = ^points_t;

var
	N: longint = 0;
	points: points_p;

procedure die( msg: string );
begin
	writeLn( msg );
	halt( 1 );
end;

function init: longint;
var
	i, j: longint;
	f: text;
	buffer: neighbors_p;
begin
	assign( f, 'xmas.in' );
	reset( f );
	readln( f, n );
	getmem( points, ( N + 1 ) * sizeof( point_t ) );
	getmem( buffer, ( N + 1 ) * 3 * sizeof( longint ) );
	for i := 1 to N do begin
		readln( f, ( points ^ )[ i ].neighbor_count );
		( points ^ )[ i ].neighbors := buffer;
		buffer := @ ( buffer ^ )[ ( points ^ )[ i ].neighbor_count + 1 ];
		for j := 1 to ( points ^ )[ i ].neighbor_count do
			read( f, ( ( points ^ )[ i ].neighbors ^ )[ j ] );
		( points ^ )[ i ].decoration := ' ';
	end;
	close( f );
	init := N;
end;

function neighbor_count( point: longint ): longint;
begin
	if N = 0 then die( 'No init called' );
	if ( point < 1 ) or ( point > N ) then
		neighbor_count := 0
	else
		neighbor_count := ( points ^ )[ point ].neighbor_count;
end;

function neighbor( point, index: longint ): longint;
begin
	if N = 0 then die( 'No init called' );
	if ( point < 1 ) or ( point > N ) then
		neighbor := 0
	else if ( index < 1 ) or ( index > ( points ^ )[ point ].neighbor_count ) then
		neighbor := 0
	else
		neighbor := ( ( points ^ )[ point ].neighbors ^ )[ index ];
end;

function decoration( point: longint ): char;
begin
	if N = 0 then die( 'No init called' );
	if ( point < 1 ) or ( point > N ) then
		decoration := ' '
	else
		decoration := ( points ^ )[ point ].decoration;
end;

function enemy: longint;
var
	point: longint;
	decoration: char;
begin
	{writeln( stderr, 'enemy' );}
	writeln( stdout, 'ENeMY!' );
	flush( stdout );
	read( point );
	if point = 0 then
		halt;
	repeat
		read( decoration );
	until decoration <> ' ';
	readln;
	{writeln( stderr, 'done' );}
	( points ^ )[ point ].decoration := decoration;
	enemy := point;
end;

procedure decorate( point: longint; decoration: char );
var
	res: longint;
begin
	writeLn( stdout, 'FroMTreeLIB:', point, ' ''', decoration, '''' );
	{writeln( stderr, 'decorate' );}
	flush( stdout );
	readln( res ); { read the ok }
	if res = 0 then
		halt;
	{writeln( stderr, 'done' );}
	( points ^ )[ point ].decoration := decoration;
end;

end.
