
#include "tree_lib.h"

#include <stdlib.h>
#include <assert.h>

#define ever ( ;; )

typedef struct node_t {
	int selected;
	int parent;
	int enq;
} node_t;

static node_t *nodes = NULL;
static int N = 0, move = 0;

static int lastDec = 1;

static int qhead = 0, qtail = 0, *queue = NULL;

static void enq( int what ) {
	for( int i = 1; i <= neighbor_count( what ); ++ i ) {
		if( nodes[ neighbor( what, i ) - 1 ].enq )
			continue;
		nodes[ neighbor( what, i ) - 1 ].enq = 1;
		queue[ qtail ++ ] = neighbor( what, i );
	}
}

static void dec( int what ) {
	struct {
		char code;
		int avail;
	} avails[] = { { 'A', 1 }, { 'B', 1 }, { 'D', 1 }, { 'S', 1 } };
	for( int i = 1; i <= neighbor_count( what ); ++ i ) {
		char t = decoration( neighbor( what, i ) );
		for( int j = 0; j < 4; ++ j )
			if( t == avails[ j ].code ) {
				avails[ j ].avail = 0;
				break;
			}
	}
	char code = 0;
	for( int i = 0; i < 4; ++ i )
		if( avails[ i ].avail ) {
			code = avails[ i ].code;
			break;
		}
	assert( code );
	decorate( what, code );
	nodes[ what - 1 ].selected = move;
	enq( what );
}

static void doMove( void ) {
	int deco = 0;
	move ++;
	while( lastDec && ( lastDec != 1 ) ) {
		if( decoration( lastDec ) != ' ' ) {
			lastDec = nodes[ lastDec - 1 ].parent + 1;
		} else if( !nodes[ lastDec - 1 ].selected ) {
			nodes[ lastDec - 1 ].selected = move;
			enq( lastDec );
			lastDec = nodes[ lastDec - 1 ].parent + 1;
		} else {
			dec( lastDec );
			deco = 1;
			break;
		}
	}
	if( !deco ) {
		if( qtail ) {
			for(;;) {
				if( decoration( queue[ qhead ] ) == ' ' ) {
					dec( queue[ qhead ] );
					break;
				}
				qhead ++;
				assert( qhead < qtail );
			}
		} else
			dec( 1 );
	}
	lastDec = enemy();
	nodes[ lastDec - 1 ].selected = move;
	enq( lastDec );
}

static void orientTree( int src, int where ) {
	nodes[ where ].parent = src;
	for( int i = 1; i <= neighbor_count( where + 1 ); ++ i ) {
		if( neighbor( where + 1, i ) - 1 == src )//No comebacks ;-)
			continue;
		orientTree( where, neighbor( where + 1, i ) - 1 );
	}
}

int main( int argc, char *argv[] ) {
	nodes = (node_t *) malloc( ( N = init() ) * sizeof *nodes );
	queue = malloc( N * sizeof * queue );
	for( int i = 0; i < N; ++ i ) {
		nodes[ i ].selected = 0;
		nodes[ i ].parent = 0;
		nodes[ i ].enq = 0;
	}
	orientTree( 0, 0 );
	for ever doMove();
	return 0;
}
